/*
 * Copyright (C) 2003 Borja Sanchez Zamorano <borsanza@terra.es>
 */

#include <GL/glut.h>
#include <GL/glpng.h>

#ifndef DOCK_H
#define DOCK_H

class Dock {

private:
  struct ListIcons {
    int posX;
    double newX;
    double width;
    struct ListIcons *prev;
    struct ListIcons *next;
		pngInfo imgInfo, imgMiniInfo;
		GLuint imgText, imgMiniText;
  } LISTICONS;

  struct ListIcons *FirstIcon, *LastIcon;

  int width, height;
  int mouseX, mouseY;
  pngInfo dockInfo[3];
  GLuint dockText[3];

  void refreshList();
  void refreshListInverse();
  void refreshSize();

public:
  Dock();
  ~Dock();

  void addIcon(int pos);
  bool isMouse();
  void resizeEvent(int widthP, int heightP);
  void mouseMoveEvent(int x, int y);
  void paintEvent();

};

#endif
