/*
 * Copyright (C) 2003 Borja Sanchez Zamorano <borsanza@terra.es>
 */

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <SDL/SDL.h>
#include "defines.h"
#include "intro.h"
#include "k1.h"

//#include <minifmod.h>
#include "music.h"
#include "window.h"
#include "dock.h"
#include "fin.h"

//#define DEBUG_EVENTS
#define MAX_SPEED_TIME      30
#define width 1024
#define height 768
void *listenUnix(void *p);

void gl_line(GLint x1, GLint y1, GLint x2, GLint y2);

pngInfo mouseInfo, wellcomeInfo;
GLuint mouseText, wellcomeText;
struct ListWindow *n1 = 0, *n2 = 0, *n3 = 0;
SDL_Surface *screen;
bool flash=false;

/************************VARIABLES GLOBALES*************************/

  int redisplay = 0;
  int win;
  int arrastrarventana=0;	//a 1 cuando tenemos seleccionada la ventana para arrastrarla
  int redimension[9];
  int px,py;			//Posicion de la ventana antes de arrastrar

  int mouseX,mouseY;

  int aux=0;
  int crec=0;
  int fullscreen=1;
  pngInfo wallInfo;
  GLuint wallText;

  struct ListWindow {
    struct ListWindow *prev;
    Window *hw;
    struct ListWindow *next;
  } LISTWINDOW;

  struct ListWindow *FirstWindow=NULL, *LastWindow=NULL;
  Dock *CDock;

/*****************************************************************************/

void actualizaListaPrev () {
  struct ListWindow *auxWindow, *auxPrev=NULL;
  auxWindow=FirstWindow;
  while (auxWindow != NULL) {
    auxWindow->prev = auxPrev;
    auxPrev = auxWindow;
    auxWindow = auxWindow->next;
  }
  LastWindow = auxPrev;
}

/*****************************************************************************/

ListWindow *nuevaVentana(int x, int y, int w, int h, int skin, float alpha = 1.0) {
  struct ListWindow *newWindow;
  newWindow = (ListWindow *) malloc (sizeof(ListWindow));
  newWindow->hw = new Window(w, h, x, y+22, skin, alpha);
  newWindow->next = FirstWindow;
  FirstWindow = newWindow;
  actualizaListaPrev();
	return newWindow;
}

/*****************************************************************************/

void initGL() {
  for (int i=0; i<9; ++i)
    redimension[i] = 0;

//  glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

/*
  glClearDepth(1.0);
  float df=100.0;
  glMaterialfv(GL_FRONT,GL_SHININESS,&df);
  glDisable(GL_DEPTH_TEST);
  glDisable(GL_ALPHA_TEST);
  glDepthFunc(GL_LEQUAL);
  glEnable(GL_CULL_FACE);
  glDisable(GL_NORMALIZE);
  glPointSize(1.0);
  glLineWidth(1.0);
  glDepthFunc(GL_LEQUAL);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
  glShadeModel(GL_SMOOTH);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
*/
}

/*****************************************************************************/

void CargarRaton() {
	mouseText = pngBind("./raton.png", PNG_NOMIPMAP, PNG_ALPHA, &mouseInfo, GL_CLAMP, GL_NEAREST, GL_NEAREST);

}

/*****************************************************************************/

void PintarRaton() {
  glColor4f(1.0f, 1.0f, 1.0f, 0.6f);
                                                                                                                               
// Borde de Arriba
  glBindTexture(GL_TEXTURE_2D, mouseText);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(mouseX, mouseY);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(mouseX, mouseY + mouseInfo.Height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(mouseX + mouseInfo.Width, mouseY + mouseInfo.Height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(mouseX + mouseInfo.Width, mouseY);
  glEnd();
}

/*****************************************************************************/

void DisplayFunc(bool isMain = false) {
  unsigned int i;
  char s[200];
  struct ListWindow *auxWindow;
	static float boomflash = 0.0;

	if (flash) {
		flash=false;
		boomflash=1.0;
	}

  redisplay = 0;

#ifdef DEBUG_EVENTS
  printf("DisplayFunc()\n");
#endif

  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
//	glLoadIdentity();
  glPushMatrix();

  glDisable(GL_BLEND);
  glColor3f(1.0f, 1.0f, 1.0f);
  glBindTexture(GL_TEXTURE_2D, wallText);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(width, height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(width, 0.0f);
  glEnd();
  glEnable(GL_BLEND);

// Ojo, hay que ir en orden inverso
  auxWindow=LastWindow;
  while (auxWindow!=NULL) {
    auxWindow->hw->draw();
    auxWindow = auxWindow->prev;
  }
/*
  sprintf(s,"Resolucion: %dx%d           Raton: %dx%d",width, height, mouseX, mouseY);

  glColor4f(0.0f, 0.0f, 0.0f, 0.3f);
  glRasterPos2f(28, 17);
  for (i=0; i<strlen(s); ++i)
    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, s[i]);

  glColor3f(0.0f, 0.0f, 0.0f);
  glRasterPos2f(27, 16);
  for (i=0; i<strlen(s); ++i)
    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, s[i]);
*/
  CDock->paintEvent();

	PintarRaton();

/*	static int flash2 =0;
	if (isMain) {
	if (boomflash>0) {
		if (flash2==3) {
		boomflash-=0.3;
	  glColor4f(1.0f, 1.0f, 1.0f,boomflash);
	  glBindTexture(GL_TEXTURE_2D, 0);
	  glBegin(GL_QUADS);
  	glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
	  glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, height);
	 	glTexCoord2f(1.0f, 1.0f); glVertex2f(width, height);
 		glTexCoord2f(1.0f, 0.0f); glVertex2f(width, 0.0f);
		glEnd(); 
		}
		flash2++;
		flash2%=4;
	
		
	}
	}*/

	glPopMatrix();
}

/*****************************************************************************/


void IdleFunc(void) {
/*
#ifdef DEBUG_EVENTS
  printf("IdleFunc()\n");
#endif
*/
  if (redisplay==1) {
    redisplay = 0;
    glutPostRedisplay();
  }
}

/*****************************************************************************/

void Redibuja() {
//  redisplay = 1;
  glutPostRedisplay();
}

/*****************************************************************************/

void ReshapeFunc (int w, int h) {
#ifdef DEBUG_EVENTS
  printf("ReshapeFunc(w=%d, h=%d)\n", w, h);
#endif
//  width = w;
//  height = h;
  glViewport (0, 0, w, h);
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
//  glOrtho(0, 0, height, width, 0, 500);
  gluOrtho2D(0, w, h, 0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  CDock->resizeEvent(w, h);
}

/*****************************************************************************/

void KeyboardFunc(unsigned char key, int x, int y) {
#ifdef DEBUG_EVENTS
  printf("KeyboardFunc(key=%d (%c), x=%d, y=%d)\n", key, key, x, y);
#endif
  switch (key) {
    case 27:
      unlink("/tmp/.Cartoon-unix/C0");
      rmdir("/tmp/.Cartoon-unix/");
      exit(0);
      break;
    case 'f':
      if (fullscreen) {
        glutReshapeWindow(width, height);
        glutPositionWindow(0,0);
      } else
        glutFullScreen();
      fullscreen = !fullscreen;
      break;
    default:
      break;
  }
}

/*****************************************************************************/

void SpecialFunc(int key, int x, int y) {
#ifdef DEBUG_EVENTS
  printf("SpecialFunc(key=%d, x=%d, y=%d)\n", key, x, y);
#endif
  switch (key) {
    case 102:
      break;
    default:
      break;
  }
}

/*****************************************************************************/

/*void MouseFunc(int button, int state, int x, int y) {
  mouseX = x;
  mouseY = height-(y+1);
  mouseY = y;
#ifdef DEBUG_EVENTS
  printf("MouseFunc(button=%d, state=%d, x=%d, y=%d)\n", button, state, x, y);
#endif

  if (button==GLUT_LEFT_BUTTON) {
    if (state==GLUT_DOWN) {

      for (int i=0; i<9; ++i)
        redimension[i]=0;
      switch (FirstWindow->hw->estaDentro(mouseX, mouseY)) {
        case MOVE:FirstWindow->hw->setDistancia((float)mouseX, (float)mouseY);redimension[MOVE]=1;break;
        case REDIM_RIGHT:redimension[REDIM_RIGHT]=1;break;
        case REDIM_LEFT:redimension[REDIM_LEFT]=1;break;
        case REDIM_UP:redimension[REDIM_UP]=1;break;
        case REDIM_DOWN:redimension[REDIM_DOWN]=1;break;
        case REDIM_DOWN_LEFT:redimension[REDIM_DOWN_LEFT]=1;break;
        case REDIM_DOWN_RIGHT:redimension[REDIM_DOWN_RIGHT]=1;break;
        case REDIM_UP_LEFT:redimension[REDIM_UP_LEFT]=1;break;
        case REDIM_UP_RIGHT:redimension[REDIM_UP_RIGHT]=1;break;
      }
    }

    if (state==GLUT_UP) {
      for(int i=0; i<9; ++i)
        redimension[i]=0;
    }
  }
}*/

/*****************************************************************************/

/*void PassiveMotionFunc(int x, int y) {
#ifdef DEBUG_EVENTS
  printf("PassiveMotionFunc(x=%d, y=%d)\n", x, y);
#endif

  mouseX = x;
  mouseY = y;

  CDock->mouseMoveEvent(mouseX, mouseY);
//Comprueba cuando entra en las zonas de redimensionado y arrastrado del marco cambiando el ptro del raton

  struct ListWindow *auxWindow=FirstWindow;
  while ((auxWindow!=NULL) && (auxWindow->hw->estaDentro(mouseX, mouseY)==NONE))
    auxWindow = auxWindow->next;

  if (auxWindow==NULL)
    glutSetCursor(GLUT_CURSOR_INHERIT);
//  else
//    redimension[auxWindow->hw->estaDentro(mouseX, mouseY)]=1;

}*/

/*****************************************************************************/

void MotionFunc(int x, int y) {
  int aux;

#ifdef DEBUG_EVENTS
  printf("MotionFunc(x=%d, y=%d)\n", x, y);
#endif

//  mouseX = x;
//  mouseY = y;

  CDock->mouseMoveEvent(mouseX, mouseY);

  if(redimension[MOVE])FirstWindow->hw->mover(mouseX, mouseY);

  if(redimension[REDIM_RIGHT])FirstWindow->hw->redimensionarVentana(mouseX, mouseY, REDIM_RIGHT);
  if(redimension[REDIM_LEFT])FirstWindow->hw->redimensionarVentana(mouseX, mouseY, REDIM_LEFT);
  if(redimension[REDIM_UP])FirstWindow->hw->redimensionarVentana(mouseX, mouseY, REDIM_UP);
  if(redimension[REDIM_DOWN])FirstWindow->hw->redimensionarVentana(mouseX, mouseY, REDIM_DOWN);
  if(redimension[REDIM_UP_RIGHT])FirstWindow->hw->redimensionarVentana(mouseX, mouseY, REDIM_UP_RIGHT);
  if(redimension[REDIM_UP_LEFT])FirstWindow->hw->redimensionarVentana(mouseX, mouseY, REDIM_UP_LEFT);
  if(redimension[REDIM_DOWN_RIGHT])FirstWindow->hw->redimensionarVentana(mouseX, mouseY, REDIM_DOWN_RIGHT);
  if(redimension[REDIM_DOWN_LEFT])FirstWindow->hw->redimensionarVentana(mouseX, mouseY, REDIM_DOWN_LEFT);

}


/*****************************************************************************/

void gl_line(GLint x1, GLint y1, GLint x2, GLint y2) {
  glBegin(GL_LINES);
  glVertex2i(x1, y1);
  glVertex2i(x2, y2);
  glEnd ();
}

/******************************************************************************/

void Prueba1(struct ListWindow *n) {
	int  w = 512;
	int h = w;
	
	glViewport(0,0,w,h);
	glLoadIdentity();
	DisplayFunc();
	glBindTexture(GL_TEXTURE_2D, n->hw->fondoText);
	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 0, 0, w, h, 0);
	
	glViewport(0 , 0, width, height);
}


/******************************************************************************/

void Prueba2(struct ListWindow *n) {
	int w = 512;
	int h = 512;
	glViewport(0,0,w, h);
	pinta_k1(w, h);
	DisplayFunc();
	
  glBindTexture(GL_TEXTURE_2D, n->hw->fondoText);
  glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 0, 0, w, h, 0);
                                                                                                                               
  glViewport(0 , 0, width, height);
}

/******************************************************************************/

void Wellcome() {
	static int npass=0;
	static float alpha = 0.0;
	static bool visible = true;
	static int cont = 0;
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  glPushMatrix();
                                                                                                                               
//  glDisable(GL_BLEND);
  glColor4f(1.0f, 1.0f, 1.0f,alpha);
  glBindTexture(GL_TEXTURE_2D, wellcomeText);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(width, height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(width, 0.0f);
  glEnd();
//  glEnable(GL_BLEND);
	char s[20];
	int i;
	if (pass) {
		npass++;
		pass=0;
	}
	for (i=0; i<npass; i++) {
	  s[i] = '*';
	}
	if (visible)
		s[i] = 'I';
	else
		s[i] = ' ';
	
	cont++;
	if (cont>=5) {
		cont=0;
		visible = !visible;
	}

	s[i+1] = '\0';
	alpha += 0.005;
                                                                                                                               
	glColor4f(0.0f, 0.0f, 0.0f, 0.3f);
	glRasterPos2f(491, 477);
	for (i=0; i<strlen(s); ++i)
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, s[i]);
                                                                                                                               
	glColor3f(0.0f, 0.0f, 0.0f);
	glRasterPos2f(490, 476);
	for (i=0; i<strlen(s); ++i)
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, s[i]);

//	mouseX = 685;
//	mouseY = 510;

	PintarRaton();

	glPopMatrix();	
}

/******************************************************************************/

void BorrarVentana(struct ListWindow **n) {
	if (n==0) return;
  struct ListWindow **aux;
	aux = &FirstWindow;
	while ((*aux != *n) && (*aux != 0))
		aux = &(*aux)->next;

	if (*aux != 0) {
		*aux = (*aux)->next;

	  actualizaListaPrev();
	}
	*n = 0;
}

/******************************************************************************/

void Boom(struct ListWindow *n) {
	if (estado2==0)
		return;
	switch(estado2) {
		case 1:
			flash=true;
			n->hw->calcularEsquinas(n->hw->getX() - 15, n->hw->getY() - 15,n->hw->ancho + 30, n->hw->alto + 30);
			break;
		case 2:
			n->hw->calcularEsquinas(n->hw->getX() + 15, n->hw->getY() + 15,n->hw->ancho - 30, n->hw->alto - 30);
	}
}

/******************************************************************************/

void Intro() {
	pinta_intro(1024,768);
}

void Fin() {
  pinta_fin(1024,768);
}

/******************************************************************************/

void DibujarEscena() {
	static int estadoant=0;
	static float alpha = 1.0;
	
	switch (estado) {
		case -10:
			Intro();
			break;
		case 0:
			Wellcome();
			break;
		case 5:
			if (n1!=0)
				n1->hw->setAlpha(alpha, alpha);
			if (n2!=0)
				n2->hw->setAlpha(alpha, alpha);
			if (alpha <= 0) {
				BorrarVentana(&n1);
				BorrarVentana(&n2);
			}
			alpha -= 0.04;
			Prueba1(n3);
			glLoadIdentity();
			DisplayFunc();
			break;
		case 4:
			if (n3 == 0)
        n3 = nuevaVentana(282, 50, 450, 300, 2);
			Boom(n1);
			Boom(n2);
			Boom(n3);
			if (estado2>0)
				estado2++;
			if (estado2>2) estado2=0;
			Prueba2(n3);
			n1->hw->setAlpha(1.0, 0.0);

		case 3:
			if (n1 == 0)
				n1 = nuevaVentana(50, 350, 450, 300, 1);
			n2->hw->setAlpha(0.6, 0.6);

			Prueba1(n1);
		case 2:
			if (n2 == 0)
				n2 = nuevaVentana(562, 350, 450, 300, 2);

			Prueba2(n2);
		case 1:
			if (estadoant==0) {
				glDeleteTextures(1, &wellcomeText);
				mouseX = width>>1;
				mouseY = height;

			}
			glLoadIdentity();
			DisplayFunc(true);
			break;
		case 6:
			Fin();
			break;
	}
	estadoant = estado;
}

/******************************************************************************/

int main(int argc, char** argv) {
	int done = 0;
	SDL_Event event;
  printf("Press ESC to quit\n");

	SDL_Init(SDL_INIT_VIDEO);
  SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
  SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

	screen = SDL_SetVideoMode(width, height, 32, SDL_OPENGL | SDL_FULLSCREEN);
	glViewport(0,0,width,height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0.0f,0.0f,-10.0f,0.0f,0.0f,0.0f,0.0f,1.0f,0.0f);
	initGL();
	SDL_ShowCursor(0);

/*struct ListWindow *newWindow;
  newWindow = (ListWindow *) malloc (sizeof(ListWindow));
  newWindow->hw = new Window(1024, 82, 0, -60, 2);
  newWindow->next = FirstWindow;
  FirstWindow = newWindow;
  actualizaListaPrev();*/
                                                                                                                               
//	n2 = nuevaVentana(50, 50, 800, 600, 1);

  wallText = pngBind("./themes/aqua/wallpaper.png", PNG_NOMIPMAPS, PNG_SOLID, &wallInfo, GL_CLAMP, GL_LINEAR, GL_LINEAR);
	wellcomeText = pngBind("./themes/aqua/wellcome.png", PNG_NOMIPMAPS, PNG_SOLID, &wellcomeInfo, GL_CLAMP, GL_LINEAR, GL_LINEAR);
  CargarRaton();                                                                                                                             
  CDock = new Dock();

	ReshapeFunc(width, height);
	Uint32 t0;
	int button = 0;
	int buttons = 0;
  initmusic();
  playmusic();

	while ((!done)&&(estado!=7)) {

		while (SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					done = 1;
					break;

				case SDL_KEYDOWN:
					switch(event.key.keysym.sym)
					{
						case SDLK_ESCAPE:
							done = 1;
							break;						
					}

				case SDL_MOUSEMOTION:
					mouseX = event.motion.x;
					mouseY = event.motion.y;
					break;
	
					
			}
		}
		MotionFunc(mouseX, mouseY);
		t0 = SDL_GetTicks();

		DibujarEscena();

		while(SDL_GetTicks()-t0 < MAX_SPEED_TIME);

		refreshevents();
		SDL_GL_SwapBuffers();
	}
	closemusic();
	SDL_Quit();
  return 0;
}
