#include <stdio.h>
#include "defines.h"
#include "minifmod.h"

static FMUSIC_MODULE *mod;

unsigned int fileopen(char *name)
{
  return((unsigned int)fopen(name, "rb"));
}

void fileclose(unsigned int handle)
{
  fclose((FILE *)handle);
}

int fileread(void *buffer, int size, unsigned int handle)
{
  return(fread(buffer, 1, size, (FILE *)handle));
}

void fileseek(unsigned int handle, int pos, signed char mode)
{
  fseek((FILE *)handle, pos, mode);
}

int filetell(unsigned int handle)
{
  return(ftell((FILE *)handle));
}

void initmusic()
{
  FSOUND_File_SetCallbacks(fileopen, fileclose, fileread, fileseek, filetell);
  FSOUND_Init(44100, 0);
  mod = FMUSIC_LoadSong("data/music.xm", NULL);
}

void closemusic()
{
  FMUSIC_StopSong(mod);
  FMUSIC_FreeSong(mod);
  FSOUND_Close();
}

void playmusic()
{
  FMUSIC_PlaySong(mod);
}

void refreshevents()
{
    static int oldrow = -1;
    int ord, row;

    ord = FMUSIC_GetOrder(mod);
    row = FMUSIC_GetRow(mod);

		if (row == oldrow)
			return;
		
    switch(ord) {
			case 0:
				if (row == 63)
					estado = 0;
				break;
	    case 1:
				if ((row == 32) || (row == 33) || (row == 39) || (row == 40) || (row == 42) || (row == 43) || (row == 44) || (row == 46)) pass=1;
				break;
			case 2:
				if (estado==0)
					estado = 1;
				break;
			case 3:
			
//				if (row == 32)
					estado = 2;
					break;
			case 4:
//				if (row == 63)
					estado = 3;
				break;
			case 5:
			case 6:
			case 7:
			case 8:
				estado = 4;
				if ((row % 4)==0)
					estado2 = 1;
				break;
			case 9:
				estado = 5;

				break;
			case 10:
				estado = 6;
				break;
			case 11:
				estado = 7;
				break;
		}
    oldrow = row;
}
