/*
 * Copyright (C) 2003 Borja Sanchez Zamorano <borsanza@terra.es>
 */

#include "window.h"

/*****************************************************************************/

Window::Window(int a, int h, int px, int py, int skin, float alp){
  alpha = alp;
	alphab = 1.0;
  alto=a;
  ancho=h;
  calcularEsquinas(px, py, a, h);

  if (skin==0) {
    topText[0] = pngBind("./themes/redmondxp/top-0-active.png", PNG_NOMIPMAP, PNG_ALPHA, &topInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    topText[1] = pngBind("./themes/redmondxp/top-1-active.png", PNG_NOMIPMAP, PNG_ALPHA, &topInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    topText[2] = pngBind("./themes/redmondxp/top-2-active.png", PNG_NOMIPMAP, PNG_ALPHA, &topInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    bottomText[0] = pngBind("./themes/redmondxp/bottom-0-active.png", PNG_NOMIPMAP, PNG_ALPHA, &bottomInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    bottomText[1] = pngBind("./themes/redmondxp/bottom-1-active.png", PNG_NOMIPMAP, PNG_ALPHA, &bottomInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    bottomText[2] = pngBind("./themes/redmondxp/bottom-2-active.png", PNG_NOMIPMAP, PNG_ALPHA, &bottomInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    leftText[0] = pngBind("./themes/redmondxp/left-0-active.png", PNG_NOMIPMAP, PNG_ALPHA, &leftInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    leftText[1] = pngBind("./themes/redmondxp/left-1-active.png", PNG_NOMIPMAP, PNG_ALPHA, &leftInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    leftText[2] = pngBind("./themes/redmondxp/left-2-active.png", PNG_NOMIPMAP, PNG_ALPHA, &leftInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    rightText[0] = pngBind("./themes/redmondxp/right-0-active.png", PNG_NOMIPMAP, PNG_ALPHA, &rightInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    rightText[1] = pngBind("./themes/redmondxp/right-1-active.png", PNG_NOMIPMAP, PNG_ALPHA, &rightInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    rightText[2] = pngBind("./themes/redmondxp/right-2-active.png", PNG_NOMIPMAP, PNG_ALPHA, &rightInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    fondoText = pngBind("./themes/redmondxp/fondo.png", PNG_NOMIPMAPS, PNG_ALPHA, &fondoInfo, GL_REPEAT, GL_LINEAR, GL_LINEAR);
  }
  if (skin==1) {
    topText[0] = pngBind("./themes/aqua/top-0-active.png", PNG_NOMIPMAP, PNG_ALPHA, &topInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    topText[1] = pngBind("./themes/aqua/top-1-active.png", PNG_NOMIPMAP, PNG_ALPHA, &topInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    topText[2] = pngBind("./themes/aqua/top-2-active.png", PNG_NOMIPMAP, PNG_ALPHA, &topInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    bottomText[0] = pngBind("./themes/aqua/bottom-0-active.png", PNG_NOMIPMAP, PNG_ALPHA, &bottomInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    bottomText[1] = pngBind("./themes/aqua/bottom-1-active.png", PNG_NOMIPMAP, PNG_ALPHA, &bottomInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    bottomText[2] = pngBind("./themes/aqua/bottom-2-active.png", PNG_NOMIPMAP, PNG_ALPHA, &bottomInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    leftText[0] = pngBind("./themes/aqua/left-0-active.png", PNG_NOMIPMAP, PNG_ALPHA, &leftInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    leftText[1] = pngBind("./themes/aqua/left-1-active.png", PNG_NOMIPMAP, PNG_ALPHA, &leftInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    leftText[2] = pngBind("./themes/aqua/left-2-active.png", PNG_NOMIPMAP, PNG_ALPHA, &leftInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    rightText[0] = pngBind("./themes/aqua/right-0-active.png", PNG_NOMIPMAP, PNG_ALPHA, &rightInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    rightText[1] = pngBind("./themes/aqua/right-1-active.png", PNG_NOMIPMAP, PNG_ALPHA, &rightInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    rightText[2] = pngBind("./themes/aqua/right-2-active.png", PNG_NOMIPMAP, PNG_ALPHA, &rightInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    fondoText = pngBind("./themes/aqua/fondo.png", PNG_NOMIPMAPS, PNG_ALPHA, &fondoInfo, GL_REPEAT, GL_LINEAR, GL_LINEAR);
  }
  if (skin==2) {
    topText[0] = pngBind("./themes/aqua/top-0-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &topInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    topText[1] = pngBind("./themes/aqua/top-1-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &topInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    topText[2] = pngBind("./themes/aqua/top-2-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &topInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    bottomText[0] = pngBind("./themes/aqua/bottom-0-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &bottomInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    bottomText[1] = pngBind("./themes/aqua/bottom-1-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &bottomInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    bottomText[2] = pngBind("./themes/aqua/bottom-2-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &bottomInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    leftText[0] = pngBind("./themes/aqua/left-0-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &leftInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    leftText[1] = pngBind("./themes/aqua/left-1-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &leftInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    leftText[2] = pngBind("./themes/aqua/left-2-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &leftInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    rightText[0] = pngBind("./themes/aqua/right-0-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &rightInfo[0], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    rightText[1] = pngBind("./themes/aqua/right-1-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &rightInfo[1], GL_CLAMP, GL_NEAREST, GL_NEAREST);
    rightText[2] = pngBind("./themes/aqua/right-2-inactive.png", PNG_NOMIPMAP, PNG_ALPHA, &rightInfo[2], GL_CLAMP, GL_NEAREST, GL_NEAREST);

    fondoText = pngBind("./themes/aqua/fondo.png", PNG_NOMIPMAPS, PNG_ALPHA, &fondoInfo, GL_REPEAT, GL_LINEAR, GL_LINEAR);
  }
}

/*****************************************************************************/

/*Calculo de las esquinas a partir de una esquina el ancho y el alto*/

void Window::calcularEsquinas(float px,float py,float a, float h){
  esquinas[0].z = esquinas[1].z = esquinas[2].z = -250;
  if (a>ANCHO_MINIMO_MARCO && h>ALTO_MINIMO_MARCO){
   ancho=a;
   alto=h;
   esquinas[0].x=px;
   esquinas[0].y=py;
   esquinas[1].x=esquinas[0].x+a;
   esquinas[1].y=esquinas[0].y;
   esquinas[2].x=esquinas[0].x+a;
   esquinas[2].y=esquinas[0].y+h;
   esquinas[3].x=esquinas[0].x;
   esquinas[3].y=esquinas[0].y+h;
  }

}

/*****************************************************************************/

Window::~Window(){

}

/*****************************************************************************/

/*Situa el marco en la posicion especificada*/

void Window::mover(float x,float y){
 calcularEsquinas(x-distanciaX, y-distanciaY, ancho, alto);
}

/*****************************************************************************/

/*Guarda la distancia desde donde se pincha el marco para ser movido hasta la esquina
inferior izquierda*/

void Window::setDistancia(float x,float y){

 distanciaX=(x-esquinas[0].x);
 distanciaY=(y-esquinas[0].y);
}

/*****************************************************************************/

void Window::redimensionarVentana(float x, float y, int red){
 switch (red){
  case REDIM_RIGHT: calcularEsquinas(esquinas[0].x,esquinas[0].y,x-esquinas[0].x,alto);break;
  case REDIM_LEFT: calcularEsquinas(x,esquinas[0].y,esquinas[1].x-x,alto);break;
  case REDIM_DOWN: calcularEsquinas(esquinas[0].x,esquinas[0].y,ancho,y-esquinas[0].y);break;
  case REDIM_UP: calcularEsquinas(esquinas[0].x,y,ancho,esquinas[2].y-y);break;
  case REDIM_DOWN_RIGHT: calcularEsquinas(esquinas[0].x,esquinas[0].y,x-esquinas[0].x,y-esquinas[0].y);break;
  case REDIM_DOWN_LEFT: calcularEsquinas(x,esquinas[0].y,esquinas[1].x-x,y-esquinas[0].y);break;
  case REDIM_UP_RIGHT:calcularEsquinas(esquinas[0].x,y,x-esquinas[0].x,esquinas[2].y-y);break;
  case REDIM_UP_LEFT:calcularEsquinas(x,y,esquinas[1].x-x,esquinas[2].y-y);break;
 }
}

/*****************************************************************************/

void Window::draw(){
  glColor4f(1.0f, 1.0f, 1.0f, alphab);

// Borde de Arriba
  glBindTexture(GL_TEXTURE_2D, topText[0]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[0].x, esquinas[0].y - topInfo[0].Height);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[0].x, esquinas[0].y);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[0].x + topInfo[0].Width, esquinas[0].y);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[0].x + topInfo[0].Width, esquinas[0].y - topInfo[0].Height);
  glEnd();

  glBindTexture(GL_TEXTURE_2D, topText[2]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[2].x - topInfo[2].Width, esquinas[0].y - topInfo[2].Height);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[2].x - topInfo[2].Width, esquinas[0].y);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[2].x, esquinas[0].y);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[2].x, esquinas[0].y - topInfo[2].Height);
  glEnd();

  glBindTexture(GL_TEXTURE_2D, topText[1]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[0].x + topInfo[0].Width, esquinas[0].y - topInfo[1].Height);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[0].x + topInfo[0].Width, esquinas[0].y);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[2].x - topInfo[2].Width, esquinas[0].y);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[2].x - topInfo[2].Width, esquinas[0].y - topInfo[1].Height);
  glEnd();

// Borde de Abajo

  if (bottomText[0] != 0) {
    glBindTexture(GL_TEXTURE_2D, bottomText[0]);
    glBegin(GL_QUADS);
    glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[0].x, esquinas[2].y);
    glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[0].x, esquinas[2].y + bottomInfo[0].Height);
    glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[0].x + bottomInfo[0].Width, esquinas[2].y + bottomInfo[0].Height);
    glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[0].x + bottomInfo[0].Width, esquinas[2].y);
    glEnd();
  }

  if (bottomText[2] != 0) {
    glBindTexture(GL_TEXTURE_2D, bottomText[2]);
    glBegin(GL_QUADS);
    glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[2].x - bottomInfo[2].Width, esquinas[2].y);
    glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[2].x - bottomInfo[2].Width, esquinas[2].y + bottomInfo[2].Height);
    glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[2].x, esquinas[2].y + bottomInfo[2].Height);
    glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[2].x, esquinas[2].y);
    glEnd();
  }
//  glDeleteTextures(1, (GLuint*)&bottomText[2]);
//  bottomText[2]=0;

  glBindTexture(GL_TEXTURE_2D, bottomText[1]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[0].x + bottomInfo[0].Width, esquinas[2].y);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[0].x + bottomInfo[0].Width, esquinas[2].y + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[2].x - bottomInfo[2].Width, esquinas[2].y + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[2].x - bottomInfo[2].Width, esquinas[2].y);
  glEnd();

// Borde Izquierdo

  glBindTexture(GL_TEXTURE_2D, leftText[0]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[0].x - leftInfo[0].Width, esquinas[0].y - topInfo[0].Height);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[0].x - leftInfo[0].Width, esquinas[0].y - topInfo[0].Height + leftInfo[0].Height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[0].x, esquinas[0].y - topInfo[0].Height + leftInfo[0].Height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[0].x, esquinas[0].y - topInfo[0].Height);
  glEnd();

  glBindTexture(GL_TEXTURE_2D, leftText[2]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[0].x - leftInfo[0].Width, esquinas[2].y - leftInfo[2].Height + bottomInfo[1].Height);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[0].x - leftInfo[0].Width, esquinas[2].y + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[0].x, esquinas[2].y + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[0].x, esquinas[2].y - leftInfo[2].Height + bottomInfo[1].Height);
  glEnd();

  glBindTexture(GL_TEXTURE_2D, leftText[1]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[0].x - leftInfo[0].Width, esquinas[0].y - topInfo[0].Height + leftInfo[0].Height);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[0].x - leftInfo[0].Width, esquinas[2].y - leftInfo[2].Height + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[0].x, esquinas[2].y - leftInfo[2].Height + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[0].x, esquinas[0].y - topInfo[0].Height + leftInfo[0].Height);
  glEnd();
// Borde Derecho

  glBindTexture(GL_TEXTURE_2D, rightText[0]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[2].x, esquinas[0].y - topInfo[1].Height);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[2].x, esquinas[0].y - topInfo[1].Height + rightInfo[0].Height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[2].x + rightInfo[0].Width, esquinas[0].y - topInfo[1].Height + rightInfo[0].Height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[2].x + rightInfo[0].Width, esquinas[0].y - topInfo[1].Height);
  glEnd();

  glBindTexture(GL_TEXTURE_2D, rightText[2]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[2].x, esquinas[2].y + bottomInfo[1].Height - rightInfo[2].Height);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[2].x, esquinas[2].y + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[2].x + rightInfo[0].Width, esquinas[2].y + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[2].x + rightInfo[0].Width, esquinas[2].y + bottomInfo[1].Height - rightInfo[2].Height);
  glEnd();

  glBindTexture(GL_TEXTURE_2D, rightText[1]);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[2].x, esquinas[0].y - topInfo[0].Height + rightInfo[0].Height);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[2].x, esquinas[2].y - rightInfo[2].Height + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[2].x + rightInfo[0].Width, esquinas[2].y - rightInfo[2].Height + bottomInfo[1].Height);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[2].x + rightInfo[0].Width, esquinas[0].y - topInfo[0].Height + rightInfo[0].Height);
  glEnd();

// Relleno
  glColor4f(1.0f, 1.0f, 1.0f, alpha);
  glBindTexture(GL_TEXTURE_2D, fondoText);

//  float a=((esquinas[2].y - esquinas[0].y)/fondoInfo.Height);

  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.0f); glVertex2f(esquinas[0].x, esquinas[2].y);
  glTexCoord2f(0.0f, 1.0f); glVertex2f(esquinas[0].x, esquinas[0].y);
  glTexCoord2f(1.0f, 1.0f); glVertex2f(esquinas[2].x, esquinas[0].y);
  glTexCoord2f(1.0f, 0.0f); glVertex2f(esquinas[2].x, esquinas[2].y);
  glEnd();
}

/*****************************************************************************/

void Window::setAlpha(float interior, float borde = 1.0) {
	alpha = interior;
	alphab = borde;
}

/*****************************************************************************/

int Window::estaDentro(int x,int y){
/*
Devuelve REDIM_INF_IZQ si el cursor esta en la esquina inferior izquierda
Igual para REDIM_INF_DER,REDIM_SUP_IZQ,REDIM_SUP_DER, REDIM_SUPERIOR, REDIM_INFERIOR,
REDIM_IZQUIERDA,REDIM_DERECHA
Devuelve MOVE si el cursor esta en la cabecera*/

 // Comprobamos si NO esta en la ventana

 if ( (x < esquinas[0].x) || (x > esquinas[2].x) || (y < esquinas[0].y) || (y > esquinas[2].y) )
  return NONE;

 // Comprobamos si esta en las esquinas del marco
 if ( ( (x<=esquinas[0].x + LONG_ESQUINA) && (y<=esquinas[0].y + ANCHO_ZONA_REDIM) ) ||
      ( (x<=esquinas[0].x + ANCHO_ZONA_REDIM) && (y<=esquinas[0].y + LONG_ESQUINA) ) ) {
//  glutSetCursor(GLUT_CURSOR_TOP_LEFT_CORNER);
  return REDIM_UP_LEFT;
 }

 if ( ( (x >= esquinas[2].x - LONG_ESQUINA) && (y >= esquinas[2].y - ANCHO_ZONA_REDIM) ) ||
      ( (x >= esquinas[2].x - ANCHO_ZONA_REDIM) && (y >= esquinas[2].y - LONG_ESQUINA) ) ) {
//  glutSetCursor(GLUT_CURSOR_BOTTOM_RIGHT_CORNER);
  return REDIM_DOWN_RIGHT;
 }

 if ( ( (x >= esquinas[1].x - LONG_ESQUINA) && (y <= esquinas[1].y + ANCHO_ZONA_REDIM) ) ||
      ( (x >= esquinas[1].x - ANCHO_ZONA_REDIM) && (y <= esquinas[1].y + LONG_ESQUINA) ) ) {
//  glutSetCursor(GLUT_CURSOR_TOP_RIGHT_CORNER);
  return REDIM_UP_RIGHT;
 }

 if ( ( (x <= esquinas[3].x + LONG_ESQUINA) && (y >= esquinas[3].y - ANCHO_ZONA_REDIM) ) ||
      ( (x <= esquinas[3].x + ANCHO_ZONA_REDIM) && (y >= esquinas[3].y - LONG_ESQUINA) ) ) {
//  glutSetCursor(GLUT_CURSOR_BOTTOM_LEFT_CORNER);
  return REDIM_DOWN_LEFT;
 }

 // Comprobamos si esta en los laterales del marco


 if ( y >= esquinas[2].y - ANCHO_ZONA_REDIM) {
//  glutSetCursor(GLUT_CURSOR_UP_DOWN);
  return REDIM_DOWN;
 }

 if ( y <= esquinas[0].y + ANCHO_ZONA_REDIM) {
//  glutSetCursor(GLUT_CURSOR_UP_DOWN);
  return REDIM_UP;
 }

 if ( x <= esquinas[0].x + ANCHO_ZONA_REDIM) {
//  glutSetCursor(GLUT_CURSOR_LEFT_RIGHT);
  return REDIM_LEFT;
 }

 if ( x >= esquinas[2].x - ANCHO_ZONA_REDIM) {
//  glutSetCursor(GLUT_CURSOR_LEFT_RIGHT);
  return REDIM_RIGHT;
 }

//  glutSetCursor(GLUT_CURSOR_INHERIT);

  return MOVE;
}

/*****************************************************************************/

float Window::getX() {
	return esquinas[0].x;
}

/*****************************************************************************/

float Window::getY() {
	return esquinas[0].y;
}

/*****************************************************************************/

void Window::loadTextures() {
}
